
C     PY ((-11, 11), (-24, 22, 24)) : (-11, 11, 24, -24, 22) # M0_
C     PY ((-11, 11), (-24, 24)) : (-11, 11, 24, -24) # M1_
      SUBROUTINE SMATRIXHEL(PDGS, NPDG, P, ALPHAS, SCALE2, NHEL, ANS)
      IMPLICIT NONE

CF2PY double precision, intent(in), dimension(0:3,npdg) :: p
CF2PY integer, intent(in), dimension(npdg) :: pdgs
CF2PY integer, intent(in) :: npdg
CF2PY double precision, intent(out) :: ANS
CF2PY double precision, intent(in) :: ALPHAS
CF2PY double precision, intent(in) :: SCALE2
      INTEGER PDGS(*)
      INTEGER NPDG, NHEL
      DOUBLE PRECISION P(*)
      DOUBLE PRECISION ANS, ALPHAS, PI,SCALE2
      INCLUDE 'coupl.inc'

      PI = 3.141592653589793D0
      G = 2* DSQRT(ALPHAS*PI)
      CALL UPDATE_AS_PARAM()
      IF (SCALE2.NE.0D0) STOP 1

      IF (NPDG.EQ.4)THEN
        IF(-11.EQ.PDGS(1).AND.11.EQ.PDGS(2).AND.24.EQ.PDGS(3).AND.
     $   -24.EQ.PDGS(4)) THEN  ! 3
          CALL M1_SMATRIXHEL(P, NHEL, ANS)
        ENDIF
      ELSE IF (NPDG.EQ.5)THEN
        IF(-11.EQ.PDGS(1).AND.11.EQ.PDGS(2).AND.24.EQ.PDGS(3).AND.
     $   -24.EQ.PDGS(4).AND.22.EQ.PDGS(5)) THEN  ! 4
          CALL M0_SMATRIXHEL(P, NHEL, ANS)
        ENDIF
      ENDIF

      RETURN
      END

      SUBROUTINE INITIALISE(PATH)
C     ROUTINE FOR F2PY to read the benchmark point.
      IMPLICIT NONE
      CHARACTER*512 PATH
CF2PY INTENT(IN) :: PATH
      CALL SETPARA(PATH)  !first call to setup the paramaters
      RETURN
      END

      SUBROUTINE GET_PDG_ORDER(PDG)
      IMPLICIT NONE
CF2PY INTEGER, intent(out) :: PDG(2,5)
      INTEGER PDG(2,5), PDGS(2,5)
      DATA PDGS/ -11,-11,11,11,24,24,-24,-24,22,0 /
      PDG = PDGS
      RETURN
      END

      SUBROUTINE GET_PREFIX(PREFIX)
      IMPLICIT NONE
CF2PY CHARACTER*20, intent(out) :: PREFIX(2)
      CHARACTER*20 PREFIX(2),PREF(2)
      DATA PREF / 'M0_','M1_'/
      PREFIX = PREF
      RETURN
      END



